#include "../aoc2022.h"

template <typename Output>
struct SDay01 : public SDay<Output> {
	//Class constructor
	using SDay<Output>::SDay;

	std::vector<int> elfs;

	//Solutions to both days
	Output part1() override final { 
		orderCalories(elfs);
		return elfs[elfs.size()-1];
	}
	Output part2() override final { 
		//If elfs has been populated (by part 1)
		if (elfs.size() > 0)
			return (elfs[elfs.size() - 1] + elfs[elfs.size() - 2] + elfs[elfs.size() - 3]);
		return 0;
	}

	void orderCalories(std::vector<int> &elfs) {
		this->input.seekg(0);
		std::string line{ "" };
		int currentElf{ 0 };

		while (std::getline(this->input, line))
		{
			if (line == "")
			{//Break to a new elf
				elfs.push_back(currentElf);
				currentElf = 0;
				continue;
			}
			//Add the new line to the current elf
			currentElf += std::stoi(line);
		}
		//Push the final elf
		elfs.push_back(currentElf);
		return std::sort(elfs.begin(), elfs.end());
	}
};
