#include "../aoc2022.h"

template <typename Output>
struct SDay06 : public SDay<Output> {
	//Class constructor
	using SDay<Output>::SDay;

	//Solutions to both days
	Output part1() override final {
		//Find the first unique packet of length 4
		return readPackets(4);
	}
	Output part2() override final { 
		//Find the first unique message of length 14
		return readPackets(14);
	}

	int readPackets(int chunkLength) {
		this->input.clear();
		this->input.seekg(0, std::ios::beg);
		int total{ 0 };
		std::string line{ "" };

		while (std::getline(this->input, line))
		{
			total += countUniqueSequence(line, chunkLength);
		}
		return total;
	}

	int countUniqueSequence(const std::string& input, int chunk) const {
		for (int i = (chunk-1); i < input.size(); i++)
		{
			std::map<char, int> map;
			bool flag{ false };

			for (int j = (chunk-1); j >= 0; j--)
			{//Look through chunk of 4 characters
				if (map.count(input[i-j]) > 0)
				{//If it has already appeared
					flag = true;
					break;
				}

				//Add it to the map
				map[input[i-j]]++;
			}
			//If the chunk is unique
			if (flag == false)
				return i+1;
			flag = false;
		}
		return 0;
	}
};