#include "days/days.h"

void runSolutions() {
	//Heap allocate all solutions
	std::vector<SDay<int>*> solutions = {
		new SDay01<int>("day01"),
		new SDay02<int>("day02"),
		new SDay03<int>("day03"),
		new SDay04<int>("day04"),
		new SDay05<int>("day05"),
		new SDay06<int>("day06"),
		new SDay07<int>("day07"),
		new SDay08<int>("day08"),
		new SDay09<int>("day09"),
		new SDay11<int>("day11"),
		new SDay12<int>("day12"),
		new SDay13<int>("day13"),
		new SDay14<int>("day14"),
		new SDay15<int>("day15"),
		new SDay16<int>("day16"),
		new SDay17<int>("day17"),
		new SDay18<int>("day18"),
		new SDay19<int>("day19"),
		new SDay20<int>("day20"),
		new SDay21<int>("day21"),
		new SDay22<int>("day22"),
		new SDay23<int>("day23"),
		new SDay24<int>("day24"),
		new SDay25<int>("day25")
	};

	for (auto& solution : solutions)
	{//Run each day in turn, recording execution times for each part
		std::cout << "          Name         Part 1           Part 2        Elapsed\n";
		std::cout << "=================================================================\n";
		std::cout << "         " << solution->name;

		//Run solutions and keep timer on each
		std::ofstream output("output/" + solution->name);

		auto start = std::chrono::steady_clock::now();
		output << solution->part1() << std::endl;
		std::chrono::duration<double> part1Time = std::chrono::steady_clock::now() - start;
		output << solution->part2();
		std::chrono::duration<double> part2Time = std::chrono::steady_clock::now() - start - part1Time;
		std::chrono::duration<double> elapsedTime = std::chrono::steady_clock::now() - start;

		std::cout << "         " << 1e3 * part1Time.count() << "ms       " << 1e3 * part2Time.count() << "ms        " << 1e3 * elapsedTime.count() << "ms\n" << std::endl;

		//Free memory for heap allocated solution
		delete solution;

		//Hold the console
		std::cin;

	}
}

int main() {
	runSolutions();
}
